unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OSC, ExtCtrls, StdCtrls, IdBaseComponent, IdAntiFreezeBase,
  IdAntiFreeze, Buttons;

type
  TForm1 = class(TForm)
    OSC1: TOSC;
    rb1: TRadioButton;
    rb2: TRadioButton;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    procedure OSC1OscInput(Sender: TObject);
    procedure rb2Click(Sender: TObject);
    procedure rb1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.OSC1OscInput(Sender: TObject);
var
  i: integer;
  x,z : double;
  xs,zs : single;
begin
  for i := 0 to Osc1.MsgCnt-1 do
  begin
    //OSC message with single numeric parameter and address /x received
    if OSC1.Address = '/x'
      then Memo1.Lines.add(format('x = %1.4f',[single(OSC1.Data1)]))
    else

    //OSC message with single numeric parameter and address /z received
    if OSC1.Address = '/z'
      then begin
        z := OSC1.Data1;
        Memo1.Lines.add(format('z = %1.4f',[single(OSC1.Data1)]));
      end
    else

    //OSC message with two single numeric parameters and address /xz received
    if OSC1.Address = '/xz'
      then begin
        xs := OSC1.Data1;
        zs := OSC1.Data2;
        Memo1.Lines.add(format('xz = %1.4f %1.4f',[xs,zs]));
        Memo1.Lines.add(format('xz = %1.4f %1.4f',[single(OSC1.Data1),single(OSC1.Data2)]));
      end
    else

    //other messages
    if OSC1.MsgParamCnt > 0
           then Memo1.Lines.Add(format('other address: %s = %1.4f',[OSC1.address,single(OSC1.Data1)]))
           else Memo1.Lines.Add(format('other address: %s',[OSC1.address]));

    OSC1.Next;
  end
end;

procedure TForm1.rb2Click(Sender: TObject);
begin
  OSC1.ListeningPort := 7001;
end;

procedure TForm1.rb1Click(Sender: TObject);
begin
  OSC1.ListeningPort := 7008;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  OSC1.Visible := Checkbox1.Checked;
end;

end.
